<!DOCTYPE html>
<html lang="ru"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Films of the film library</title>
    <script th:inline="javascript">
        let flag = [[${exception}]];
        window.onload = () => {
            if (flag) new bootstrap.Modal(document.getElementById('deleteErrorModal'), {keyboard: false}).show()
        };
    </script>
    <style>
        .film-link {
            text-decoration: none;
        }

        .film-link:hover {
            color: #001445;
        }
    </style>
</head>
<body>
<div layout:fragment="content">
    <div>
        <hr class="hr"/>
        <h3>Поиск фильма</h3>
        <form method="POST" th:action="@{/films/search}" th:object="${filmSearchForm}">
            <div class="mt-0 row g-2">
                <div class="col-md">
                    <div class="form-floating">
                        <input name="filmTitle" type="text" class="form-control" id="filmTitle" placeholder="Title">
                        <label for="filmTitle">Title</label>
                    </div>
                </div>
                <div class="col-md">
                    <div class="form-floating">
                        <input name="directorsFio" type="text" class="form-control" id="directorsFio" placeholder="FIO Director">
                        <label for="directorsFio">Director</label>
                    </div>
                </div>
                <div class="col-md">
                    <div class="form-floating">
                        <select class="form-select" name="genre" id="genre">
                            <option selected th:value="null">Choose a genre from the list:</option>
                            <option th:each="genre : ${T(com.grs.myproject.cinematronic.model.Genre).values()}"
                                    th:value="${genre}" th:text="${genre.getGenreTextDisplay()}"></option>
                        </select>
                        <label for="genre">Genre</label>
                    </div>
                </div>
                <div class="row g-2">
                    <button type="submit" class="btn btn-secondary">Find a Film</button>
                </div>
            </div>
        </form>
    </div>
    <hr class="mt-3 hr"/>
    <div class="mt-5">
        <div class="row">
            <div class="col">
                <h2>All Films</h2>
            </div>
            <div sec:authorize="isAuthenticated() && (hasRole('ADMIN') || hasRole('LIBRARIAN'))" class="col">
                <a href="films/add"
                   class="btn btn-secondary"
                   role="button"
                   style="float: right"
                   aria-disabled="true">Add Film</a>
            </div>
        </div>
        <div>
            <table class="table table-hover mt-3">
                <thead>
                <tr>
                    <th scope="col">Title</th>
                    <th scope="col">Year of premier</th>
                    <th scope="col">Country</th>
                    <th scope="col">Genre</th>
                    <th scope="col">Director(s)</th>
                    <th sec:authorize="isAuthenticated() && (hasRole('ADMIN') || hasRole('LIBRARIAN'))" scope="col">Add Director</th>
                </tr>
                </thead>
                <tbody>
                <tr th:each="film : ${films}">
                    <td>
                        <a class="film-link" th:href="'/films/' + ${film.getId()}" th:text="${film.getFilmTitle()}"></a>
                    </td>
                    <td th:text="${film.getPremierYear()}"></td>
                    <td th:text="${film.getCountry()}"></td>
                    <td th:text="${film.getGenre().getGenreTextDisplay()}"></td>
                    <td>
                        <ul>
                            <li th:each="director : ${film.getDirectors()}" th:text="${director.getDirectorsFio()}"></li>
                        </ul>
                    </td>
                    <td>
                        <a sec:authorize="isAuthenticated() && (hasRole('ADMIN') || hasRole('LIBRARIAN'))" th:href="'/films/addDirector/'+ ${film.getId()}"
                           class="btn btn-primary" role="button"
                           aria-disabled="true">Add Director</a>
                    </td>
                    <td>
                        <div sec:authorize="isAuthenticated() && (hasRole('ADMIN') || hasRole('LIBRARIAN'))">
                            <a class="btn btn-sm btn-outline-success" th:href="'/films/update/' + ${film.id}">Update</a>
                            <a th:if="${!film.isDeleted()}" class="btn btn-sm btn-outline-danger" th:href="'/films/delete/' + ${film.id}"
                               onclick="return confirm('Do you really want to delete the movie?')">Удалить</a>
                            <a th:if="${film.isDeleted()}" class="btn btn-sm btm-outline-warning" th:href="'/films/restore/' + ${film.getId()}">Recovery</a>
                        </div>
                        <a sec:authorize="hasRole('USER')" class="btn btn-sm btn-outline-success"
                           th:href="'/rent/film/' + ${film.id}">Rent a movie</a>
                        <a sec:authorize="hasRole('USER')" class="btn btn-sm btn-outline-success"
                           th:href="'/buy/film/' + ${film.id}">Buy a movie</a>

</div>
</body>
</html>